/*=====================================
 * BUMP pour rts
 * (c) BoBo
 *=====================================
 */

 #include <allegro.h>
 #include "rtsdat.h"
 #include <math.h>

#define     RESX      32
#define     RESY      32

#define     LOOPX      64
#define     LOOPY     128

 extern   BITMAP   * finalbmp;
 extern   DATAFILE * datfile;


 static   BITMAP   * image;
 static   RGB      * pal;
 static   RGB        palk[256];

 static   int        CheminX[LOOPX];
 static   int        CheminY[LOOPY];

typedef     struct
            {
                int     x;
                int     y;
            }
            point;


/*=========================
 * PRIMITIVES
 *=========================
 */

static dr_bump( point LightPos )
{
    int     x, y;
    int     iDiffx;             // Indices de diffrence entre les normale
    int     iDiffy;             // de luminosit et du point
    point       LNormale;       // Normale du vecteur lumire
    point       NNormale;       // Normale du point courant

    for( y=1; y<RESY-1; y++ )
    {
        // Calcul de la normale du point lumineux en Y
        LNormale.y = (int)((y - LightPos.y));
        for( x=1; x<RESX-1; x++ )
        {
            // Calcul de la normale du point courant en Y
            NNormale.y = image->line[y+1][x] - image->line[y-1][x];
            // Indice de diffrence entre normale lumire et normale courante en Y
            iDiffy = 31-abs( LNormale.y - NNormale.y );
            if ( iDiffy < 0 ) iDiffy = 0;
            // Calcul normale lumire en X
            LNormale.x =(int) ((x - LightPos.x));
            // Calcul normale du point courant en X
            NNormale.x = image->line[y][x+1] - image->line[y][x-1];
            // Indice de diffrence en X
            iDiffx = 31-abs( LNormale.x - NNormale.x );
            if (iDiffx < 0 ) iDiffx = 0;
            // Couleur du point courant
            finalbmp->line[y][x] = ((iDiffx * iDiffy) >> 3);
        }
    }
}

/*=============================
 * PRINCIPALES
 *=============================
 */


prepare_bump2()
{
    int     i;
    image = (BITMAP *)datfile[ROTOM1_PCX].dat;
    pal   = (RGB *)datfile[BBUMP_PAL].dat;

    // Calcule le chemin de la louze !
    for( i=0; i<LOOPX; i++ ) CheminX[i] = (int) ( (sin( 2 * PI * i / LOOPX )+1)*(RESX>>1) );
    for( i=0; i<LOOPY; i++ ) CheminY[i] = (int) ( (sin( 2 * PI * i / LOOPY )+1)*(RESY>>1) );

    for( i=0; i<128 ; i++ ) palk[i] = pal[i];

}



do_bump2(int iter)
{
    int     xInc = 1;           // Incrment de dcalage
    int     yInc = 1;           // idem
    point   LPos;               // Position du centre de luminosit
    int     it = iter & 31;

    xInc = yInc = 3;

    xInc = iter & 63;
    yInc = iter & 127;
    LPos.x = CheminX[xInc];
    LPos.y = CheminY[yInc];

    dr_bump( LPos );
}


fix_bump2()
{
    set_palette_range( palk, 0, 128,0 );
}



stop_bump2()
{
   return(0);
}

