/*====================================
 * CUBE DE LA FIN
 * (c) Disk91 / TeKnO-BeDoUiNs / 1998
 *====================================
 */

 #include <allegro.h>
 #include "rtsdat.h"

 #define NUM_FACE  6
 #define NUM_POINT 8

 extern  BITMAP   *  dblbuff;
 extern  DATAFILE *  datfile;
 extern  BITMAP   *  ROTO_DST;
 extern  int         ROTO_SRC[4096];
         BITMAP   *  finalbmp;


 typedef struct FACE {
                       BITMAP    *  texture;
                       int          ptin[4];
                       V3D          ptout[4];
                     } FACE;


 static BITMAP  * texture1;
 static BITMAP  * texture2;
 static BITMAP  * texture3;
 static BITMAP  * texture4;
 static BITMAP  * texture5;
 static BITMAP  * texture6;
 static RGB     * pal;
 static BITMAP  * roto;



/*================================
 * definition de l'objet
 *================================
 */
 static V3D       points[8] = {  { -32 << 16, -32 << 16, -32 << 16 },
                                 { -32 << 16,  32 << 16, -32 << 16 },
                                 {  32 << 16,  32 << 16, -32 << 16 },
                                 {  32 << 16, -32 << 16, -32 << 16 },
                                 { -32 << 16, -32 << 16,  32 << 16 },
                                 { -32 << 16,  32 << 16,  32 << 16 },
                                 {  32 << 16,  32 << 16,  32 << 16 },
                                 {  32 << 16, -32 << 16,  32 << 16 } };

 static FACE      face[6] = {    { NULL, 0, 3, 2, 1 },
                                 { NULL, 4, 5, 6, 7 },
                                 { NULL, 0, 1, 5, 4 },
                                 { NULL, 2, 3, 7, 6 },
                                 { NULL, 0, 4, 7, 3 },
                                 { NULL, 1, 2, 6, 5 }
                            };

 static fixed     txtcoord[48] = { /* face 1 */  0,32, 32,32, 32, 0,  0, 0,
                                   /* face 2 */ 32, 0, 32,32,  0,32,  0, 0,
                                   /* face 3 */ 32,32, 32, 0,  0, 0,  0,32,
                                   /* face 4 */  0, 0,  0,32, 32,32, 32, 0,
                                   /* face 5 */  0, 0,  0,32, 32,32, 32, 0,
                                   /* face 6 */  0,32, 32,32, 32, 0, 32, 0  };


 static fixed     rx,ry,rz,tx,ty,tz;

/*====================================
 * PRIMITIVES
 *====================================
 */

static int cmp(const void *e1, const void *e2)
{
   FACE *q1 = (FACE *)e1;
   FACE *q2 = (FACE *)e2;

   fixed d1 = q1->ptout[0].z + q1->ptout[1].z + q1->ptout[2].z + q1->ptout[3].z;
   fixed d2 = q2->ptout[0].z + q2->ptout[1].z + q2->ptout[2].z + q2->ptout[3].z;

   return d2 - d1;
}



 static dr_object(int mode)
 {
    int     i;
    MATRIX  mat;
    V3D     pts[NUM_POINT];

    /*--- transformation des faces ---*/
    get_transformation_matrix(&mat,itofix(1),rx,ry,rz,tx,ty,tz);
    for ( i = 0 ; i < NUM_POINT ; i++ )
    {
       apply_matrix(&mat,points[i].x,points[i].y,points[i].z,
                         &pts[i].x,  &pts[i].y,  &pts[i].z );
       persp_project(pts[i].x, pts[i].y, pts[i].z, &pts[i].x, &pts[i].y);
    }
    /*--- recopie des coordonnees ---*/
    for ( i = 0 ; i < NUM_FACE ; i++)
    {
       face[i].ptout[0].x = pts[face[i].ptin[0]].x;
       face[i].ptout[0].y = pts[face[i].ptin[0]].y;
       face[i].ptout[0].z = pts[face[i].ptin[0]].z;
       face[i].ptout[1].x = pts[face[i].ptin[1]].x;
       face[i].ptout[1].y = pts[face[i].ptin[1]].y;
       face[i].ptout[1].z = pts[face[i].ptin[1]].z;
       face[i].ptout[2].x = pts[face[i].ptin[2]].x;
       face[i].ptout[2].y = pts[face[i].ptin[2]].y;
       face[i].ptout[2].z = pts[face[i].ptin[2]].z;
       face[i].ptout[3].x = pts[face[i].ptin[3]].x;
       face[i].ptout[3].y = pts[face[i].ptin[3]].y;
       face[i].ptout[3].z = pts[face[i].ptin[3]].z;
    }

    /*--- trie sur z ---*/
    qsort(face, NUM_FACE, sizeof(FACE), cmp);


    /*--- affichage ---*/
    for ( i = 0 ; i < NUM_FACE ; i++ )
    {
      if (polygon_z_normal(&face[i].ptout[0], &face[i].ptout[1], &face[i].ptout[2]) > 0)
      {
         /*--- eclairage ---*/
         face[i].ptout[0].c = MID(55, 300-((fixtoi(face[i].ptout[0].z) )) , 255);
         face[i].ptout[1].c = MID(55, 300-((fixtoi(face[i].ptout[1].z) )) , 255);
         face[i].ptout[2].c = MID(55, 300-((fixtoi(face[i].ptout[2].z) )) , 255);
         face[i].ptout[3].c = MID(55, 300-((fixtoi(face[i].ptout[3].z) )) , 255);


         quad3d(dblbuff,mode,face[i].texture,
                &face[i].ptout[0],&face[i].ptout[1],&face[i].ptout[2],&face[i].ptout[3] );
      }
    }
 }


/*====================================
 * PRINCIPALES
 *====================================
 */

 Calc_Final()
 {
    int     c,i;
    RGB   * pali = (RGB *)datfile[ROTOM1_PAL].dat;
    RGB     pal2[256];
    RGB     black = {  0,0,0,0 };

    for ( i = 0 ; i < 128 ; i++ )
          pal2[i+1] = pali[i];
    for ( i = 129 ; i < 255; i++ )
          pal2[i] = black;

    color_map = malloc(sizeof(COLOR_MAP));
    create_light_table(color_map, pal2, 0, 0, 0, NULL);
 }



 prepare_final()
 {
    int i,j;
    RGB white = {63,63,63,0};
    RGB palz[256];

    for ( i = 0 ; i < 6 ; i++ )
      for ( j = 0 ; j < 4 ; j++ )
      {
        face[i].ptout[j].u = txtcoord[(i<<3) + (j<<1)] << 16;
        face[i].ptout[j].v = txtcoord[(i<<3) + (j<<1)+1] << 16;
      }
     pal = (RGB *)datfile[ROTOM1_PAL].dat;

    texture1 = datfile[ROTOM1_PCX].dat;
    texture2 = datfile[ROTOM1_PCX].dat;
    texture3 = datfile[ROTOM1_PCX].dat;
    texture4 = datfile[ROTOM1_PCX].dat;
    texture5 = datfile[ROTOM1_PCX].dat;
    texture6 = datfile[ROTOM1_PCX].dat;

     for ( i = 0 ; i < 128 ; i++ )
          palz[i+1] = pal[i];
     for ( i = 0 ; i < texture1->h ; i++ )
       for ( j = 0 ; j < texture1->w ; j++ )
         (char)texture1->line[i][j] = (char)texture1->line[i][j] + 1;

    face[0].texture = texture1;
    face[1].texture = texture2;
    face[2].texture = texture3;
    face[3].texture = texture4;
    face[4].texture = texture5;
    face[5].texture = texture6;

    set_palette_range(palz,1,129,0);
    set_projection_viewport(0,0,640,480);
    roto = create_bitmap(32,32);
    ROTO_DST = roto;

    for ( i = 0 ; i < texture1->h ; i++ )
      for ( j = 0 ; j < texture1->w ; j++ )
         ROTO_SRC[(i << 6) + j] = (int) texture1->line[i][j];

    finalbmp=create_bitmap(32,32);
    clear(finalbmp);
    set_color(255,&white);
 }


 do_final(int iter)
 {

    rx = ( (4*iter) & 255 ) << 16;
    ry = ( (4*iter) & 255 ) << 16;
    rz = 0;//( (4*iter) & 255 ) << 16;

    if ( (iter & 255) < 64 )
      tx = ((iter & 255) << 16);
    else
       if ( ( iter & 255 ) < 192 )
          tx = ((128-(iter & 255) ) << 16);
       else
          tx = (-64 << 16)+(((iter & 255) - 192) << 16);


    if ( (iter & 255 ) < 128 )
       ty = 50*fsin((iter & 255) << 17);
    else
       ty = -50*fsin(((iter-128) & 255) << 17);

    tz = (170 << 16)+30*fsin((iter & 63) << 18);

    if ( iter > 900 )
    {
       do_bump2(iter);
       face[0].texture = finalbmp;
       face[1].texture = finalbmp;
       face[2].texture = finalbmp;
       face[3].texture = finalbmp;
       face[4].texture = finalbmp;
       face[5].texture = finalbmp;
       dr_object(POLYTYPE_ATEX);
    }

    if( iter > 450 && iter < 900 )
    {
      do_roto(iter-200,0,0,32,32,0);
      face[0].texture = roto;
      face[1].texture = roto;
      face[2].texture = roto;
      face[3].texture = roto;
      face[4].texture = roto;
      face[5].texture = roto;
      dr_object(POLYTYPE_PTEX_LIT);
    }

    if ( iter < 450 )
       dr_object(POLYTYPE_PTEX_LIT);


    blit(face[0].texture,dblbuff,0,0,607,0,32,32);
    blit(face[1].texture,dblbuff,0,0,0,0,32,32);
    blit(face[2].texture,dblbuff,0,0,607,447,32,32);
    blit(face[3].texture,dblbuff,0,0,0,447,32,32);
    rect(dblbuff,0,0,32,32,255);
    rect(dblbuff,607,0,639,32,255);
    rect(dblbuff,0,447,32,479,255);
    rect(dblbuff,607,447,639,479,255);
 }

 stop_final( )
 {
   return 0;
 }









