/*===========================================
 * Deformation pour la rts
 * (c) Bobo /TeKnO-BeDoUiNs/ 1997
 *===========================================
 */

#include <math.h>
#include <allegro.h>
#include "rtsdat.h"

extern           BITMAP   * dblbuff;
extern           DATAFILE * datfile;

static           int    * tab1;                      // image 1 : vagues             //
static           int    * tab2;                      // image 2 : cercles            //

static           int    * Mvt1X;                     // precalc deplacement des maps //
static           int    * Mvt1Y;

static           int      k,z,h;

static           int      box_w;
static           int      box_h;
static           RGB      pal[256];
static           PALETTE  courante;

//ͻ
//     Effectue le prcalcul de tab1  et tab2                              
//ͼ
CalcTab1()
//
{

    volatile unsigned int i,j,k;

    // allocation de la memoire //

      Mvt1X = (int *)(malloc(200*sizeof(int)));
      Mvt1Y = (int *)(malloc(200*sizeof(int)));
      tab1  = (int *)(malloc(256000*sizeof(int)));
      tab2  = (int  *)(malloc(64000*sizeof(int)));

      if ( tab1 == NULL || tab2 == NULL || Mvt1X == NULL || Mvt1Y == NULL )
        {
          allegro_exit();
          printf("\n Plasma_001 : Memoire insufisante pour le precalcul\n             Necessite  813 Ko\n");
          return(0);
        }

    // calcul des images de map //

    for (k = 0 , i = 0 ; i < 400 ; i++ )
       for ( j = 0 ; j < 640 ; j++ , k++ )
          tab1[k]=(int) ((cos(i*0.00981747704244)+cos(j*0.0436332312998))*16);

    for (k = 0 , i = 0 ; i < (box_h << 1) ; i++ )
       for ( j = 0 ; j < (box_w << 1) ; j++ , k++ )
            tab2[k]=(sin(sqrt((box_h-i)*(box_h-i)+(box_w-j)*(box_w-j))/9.5)+1)*8.0+32;

    return(0);

}


//ͻ
//     Effectue le prcalcul des deplacement des maps                      
//ͼ
CalcTab2()
//
{
    int cx,cy;
    int i,j;

    cx = box_w >> 1;
    cy = box_h >> 1;

    for ( i=0;i < 100;i++ )
    {
       Mvt1X[i] = (int)(cx+cx*cos(i*3.6*0.0174532925199));
       Mvt1Y[i] = (int)(cy+cy*sin(i*3.6*0.0174532925199));
    }

    for ( i=100;i < 150;i++ )
    {
       Mvt1X[i] = (int)(box_w-(i-100)*(box_w/50.0));
       Mvt1Y[i] = (int)(cy);
    }
    for ( i=150;i < 200;i++ )
    {
       Mvt1X[i] = (int)((i-150)*(box_w/50.0));
       Mvt1Y[i] = (int)(cy);
    }


}



//ͻ
//     Dfinit un palette 'sunuosidale'                                    
//ͼ
static void DoPalette()
//
{
  RGB color;
  volatile double r = 16 , g = 22 , b = 15;
  volatile int    i;
  RGB  * palplasma = (RGB *)datfile[PLASMA_PAL].dat;

  for ( i = 128 ; i < 255 ; i++ )
      pal[i]=palplasma[i];

/*
  for ( i = 128 ; i < 192 ; i++ , r+=0.67187 , g+=0.28125, b-=0.09375)
  {
     color.r = r; color.g = g; color.b = b;
     pal[i]  = color;
  }
  for ( i = 192 ; i < 256 ; i++ , r-=0.67187 , b-=0.28128, g-=0.09375 )
  {
     color.r = r; color.g = g; color.b = b;
     pal[i]  = color;
  }

//  set_palette_range(pal, 128, 255, 0 );
*/
}

//ͻ
//     Calcule l'image;                                                    
//ͼ

static void DoPlasma0( int x1,int y1,int x2,int y2,int x3,int y3,int x,int y )
//
{
  int i,j;
  int val;
  char * ofs;

  for ( i = 0 ; i < box_h  ; i++ )
  {
    ofs = dblbuff->line[y+i]+x;
    for ( j = 0 ; j < box_w ; j ++ , ofs++)
       *ofs = (char)( tab2[320*(i+y2)+(j+x2)] +128);
  }
}
static void DoPlasma1( int x1,int y1,int x2,int y2,int x3,int y3,int x,int y )
//
{
  int i,j;
  int val;
  char * ofs;

  for ( i = 0 ; i < box_h  ; i++ )
  {
    ofs = dblbuff->line[y+i]+x;
    for ( j = 0 ; j < box_w ; j ++ , ofs++)
       *ofs =(char)( tab2[320*(i+y2)+(j+x2)] + tab2[320*(i+y3)+(j+x3)] +128);
  }
}
static void DoPlasma2( int x1,int y1,int x2,int y2,int x3,int y3,int x,int y )
//
{
  int i,j;
  int val;
  char * ofs;

  for ( i = 0 ; i < box_h  ; i++ )
  {
    ofs = dblbuff->line[y+i]+x;
    for ( j = 0 ; j < box_w ; j ++ , ofs++)
      *ofs = (char)(tab1[320*(i+y1)+(x1+j)] + tab2[320*(i+y3)+(j+x3)] +128);
  }
}

static void DoPlasma3( int x1,int y1,int x2,int y2,int x3,int y3,int x,int y )
//
{
  int i,j;
  int val;
  char * ofs;

  for ( i = 0 ; i < box_h  ; i++ )
  {
    ofs = dblbuff->line[y+i]+x;
    for ( j = 0 ; j < box_w ; j ++ , ofs++)
      *ofs = (char )(tab1[320*(i+y1)+(x1+j)] + tab2[320*(i+y2)+(j+x2)]
                                             + tab2[320*(i+y3)+(j+x3)] +128);
  }
}

/*============================================
 * FONCTIONS PRINCIPALES
 *============================================
 */

Calc_Defo()
{
   box_w = 160;
   box_h = 100;
   CalcTab1();
   CalcTab2();
}

prepare_deform()
{
   RGB white = {63,63,63,0};
   DoPalette();
   z=50;
   h=99;
   k=0;
   set_color(97,&white);
}



//
do_deform(int iter, int x, int y, int mode, int fondu)
//
{
    if ( fondu  && iter < 64 )
    {
      fade_interpolate(black_palette, pal, courante, k , 128, 255 );
      set_palette_range(courante, 128, 255, 0);
    }

    rect(dblbuff, x, y, x+box_w+1,y+box_h+1,97);
    x++;y++;
    switch ( mode )
    {
        case 0 : DoPlasma0( -1,0,Mvt1X[h],Mvt1Y[h],-1,0,x,y );
                 break;

        case 1 : DoPlasma1( -1,0,Mvt1X[h],Mvt1Y[h],Mvt1X[z],Mvt1Y[z],x,y );
                 break;

        case 2 : DoPlasma2( Mvt1X[k],Mvt1Y[k],-1,0,Mvt1X[z],Mvt1Y[z],x,y );
                 break;

        case 3 : DoPlasma3( Mvt1X[k],Mvt1Y[k],Mvt1X[h],Mvt1Y[h],Mvt1X[z],Mvt1Y[z],x,y );
                 break;

    }
    k++; if ( k == 200 ) k = 0;
    z--; if ( z <    0 ) z = 99;
    h--; if ( h <    0 ) h = 99;

}


////

stop_deform()
  {
     free(tab1);
     free(tab2);
     free(Mvt1X);
     free(Mvt1Y);
  }

