 /*==============================================================
  * Demo pour la party RTS - Grenoble les 5-7 septembre 1998
  * (c) Disk91 / TeKnO-BeDoUiNs /
  * Contact Disk@infonie.fr
  *==============================================================
  */

  #include <allegro.h>
  #include <libamp.h>
  #include <dsk_mp3.h>
  #include "rtsdat.h"

  #define _FINAL_

  extern RGB pal_anim4[256];

  /*===========================================
   * Globales a tous les fichiers
   *===========================================
   */
   DATAFILE   *   datfile;                      /* fichier des donnees */
   BITMAP     *   dblbuff;

 wait_vbl()
 {
   poll_amp();
   while (   inportb(0x3DA) & 8  );
   while ( !(inportb(0x3DA) & 8) );
 }

 main()
 {
  /*==========================================
   * Les Variables locales
   *==========================================
   */
   int           iteration;                            /* index */
   int           iter_move;
   int           iter_depl;
   int           iter_wobb;
   int           iter_scroll;
   int           iter_cube;
   int           up;
   int           sync;
   int           synclast;
   int           last_retrace_count;

   BITMAP    *   tampon;
   PALETTE       tamp_pal;
   PALETTE       tamp_pal2;
   RGB           white = { 63,63,63, 0 };
   RGB           black = {  0, 0, 0, 0 };

  /*==========================================
   * Les inits
   *==========================================
   */

    /*--- installation d'allegro ---*/
    allegro_init();
    install_keyboard();
    if (install_sound(DIGI_AUTODETECT,MIDI_NONE,NULL))
    {
      allegro_exit();
      puts(" Error for sound card init \n");
    }
    install_timer();
    install_amp();
    amp_reverse_phase=1;

    /*--- le mode gfx ---*/
    set_color_depth(8);
    if ( set_gfx_mode(GFX_AUTODETECT, 640, 480, 640, 480) < 0 )
    {
       allegro_exit();
       puts(" Error for graphic mode : 640x480x256\n");
    }
    dblbuff = create_bitmap(640,480);
    tampon  = create_bitmap(640,480);
    clear(dblbuff);

    /*--- le fichier des donnees ---*/
    if ( !(datfile = load_datafile("rts.dat")) )
    {
       allegro_exit();
       puts(" Error while loading dat file : rts.dat \n");
    }

  /*==========================================
   * Les trucs faits bien avant
   *==========================================
   */
    Calc_Roto();
    Calc_Defo();
    Calc_Rts();
    Calc_Cube();
    Calc_123();
    Calc_Final();
    prepare_rebour();
    prepare_stars();
    prepare_anim5();
  /*==========================================
   * C'est parti
   *==========================================
   */
    /*--- mp3 --- */

    if ( load_amp("rts.mp3",FALSE) == FALSE )
    {
      allegro_exit();
      puts(" Error during loading mp3 file\n");
    }
    run_amp();

    /*--- intro ---*/

 #ifdef _FINAL_
    prepare_intro();

    iteration=0;
    while ( !keypressed() && amp_frame < 700 )
    {
       poll_amp();
       do_intro(iteration);
       iteration++;
       wait_vbl();
       wait_vbl();
    }

    run_amp();
    stop_intro();

    /*--- Compte a rebour 3D morph ---*/

    run_amp();

    iteration=0;
    iter_move=0;
    while ( !keypressed() && amp_frame < 1240 )
    {
       poll_amp();
       do_rebour(iteration);
       if ( iteration & 31 )
         iteration  ++;
       else
       {
         iter_move ++;
         if (iter_move == 31)
         {
            iteration++;
            iter_move = 0;
         }
       }
       wait_vbl();
       blit(dblbuff,screen,0,0,0,0,640,480);
    }

    run_amp();
    clear(screen);
    stop_rebour();

    /*--- La suite les anim et des trucs dessus ---*/
    prepare_roto();
    prepare_deform();
    prepare_anim1();

    iteration = 0;
    iter_move = 0;
    iter_depl = 0;
    up = 0;
    while ( !keypressed() && amp_frame < 1900 )
    {
       poll_amp();
       do_anim1( iteration , 1 );
       if ( iteration > 55 )
          do_roto(iteration - 55,100,280,121,100,1);
       if ( amp_frame > 1500 )
       {
          do_deform( iter_move, 450, 100+iter_depl, 1, 1 );
          iter_move++;
          if ( iter_move > 40 )
             if ( iter_depl < 200 && !up )
                iter_depl+=5;
             else
                up = 1;
             if ( iter_depl > 0 && up )
                iter_depl-=5;
             else
                up = 0;
       }
       if ( amp_frame > 1800 )
         stop_part1(((amp_frame-1800)*64)/200);

       wait_vbl();
       finalise_anim1();
       blit(dblbuff,screen,0,0,0,0,640,480);
       iteration++;
    }

    /*--- La suite une partie r.t.s ---*/

    iter_scroll = 0;
    iter_move = 0;
    iter_depl = 63;
    iter_wobb = 0;
    prepare_rts();
    prepare_wobber();
    prepare_scroll();
    while ( !keypressed() && amp_frame < 2825 )
    {
       clear(dblbuff);
       poll_amp();
       if ( amp_frame < 2000 )
       {
          stop_part1(((amp_frame-1800)*64)/200);
          do_anim1( iteration , 1 );
          iteration++;
       }

       do_stars(iter_move);
       iter_move++;
       if ( (amp_frame > 2000 && amp_frame < 2300) || (iter_depl & 63) != 63 )
       {
          do_rts(iter_depl);
          fix_scroll(255);
          iter_depl++;
       }

       if ( amp_frame > 2300 )
       {
          do_wobber(iter_wobb);
          do_scroll(iter_scroll,255);
          iter_scroll++;
          iter_wobb++;
       }

       wait_vbl();
       if ( amp_frame < 2000 )
       {
          finalise_anim1();
          fix_pal_stars();
       }
       if ( amp_frame > 2300 )
          fix_wobber();

       blit(dblbuff,screen,0,0,0,0,640,480);
    }
    stop_anim1();

    /*--- retour sur une partie rapide ---*/
    clear(dblbuff);
    do_stars(iter_move);                    /* ce qui sert de fond */
    blit(dblbuff,tampon,0,0,0,0,640,480);
    get_palette(tamp_pal);                  /* decale le fond */
    prepare_rebour2(tampon,tamp_pal);

    sync      = 1;
    synclast  = 1;
    iteration = 128;
    while ( !keypressed() && amp_frame < 2890 )
    {
      poll_amp();
      do_rebour2(iteration);
      do_scroll(iter_scroll,255);
      iter_scroll++;

      if ( sync > synclast || (iteration & 31) != 0 )
      {
         iteration-=16;
         synclast = sync;
      }

      if ( amp_frame > 2850 ) sync = 2;
      if ( amp_frame > 2870 ) sync = 3;

      wait_vbl();
      blit(dblbuff,screen,0,0,0,0,640,480);
    }
    stop_rebour2();
    if( !keypressed())
    {
        run_amp();
        stop_123();
        poll_amp();
        stop_123();
        poll_amp();
    }

/*--- seconde partie rapide ---*/

    iteration = 0;
    iter_move = 0;
    prepare_anim2();
    prepare_greets(126);
    prepare_deform();
    fix_scroll(127);
    while ( !keypressed() && amp_frame < 3500 )
    {
       poll_amp();

       do_anim2(iteration,1);
       if ( iteration > 50 )
       {
          do_deform( iter_move, 240+fixtoi(30*fcos((( iter_move << 2 ) & 255) << 16) ),
                                190+fixtoi(30*fsin((( iter_move << 2 ) & 255) << 16) ),
                                2, 1 );
          iter_move++;

       }


       if ( iter_scroll < 1270 )
       {
          do_scroll(iter_scroll,127);
          iter_scroll++;
       }

       if ( iteration > 150 )
          do_greets(iteration-150,0,126,200);

       if ( amp_frame > 3400 )
         stop_part2(((amp_frame-3400)*64)/200);

       iteration++;
       wait_vbl();
       fix_greets(126);
       finalise_anim2();
       blit(dblbuff,screen,0,0,0,0,640,480);
    }

    /*--- seconde partie lente ---*/

    iter_move = 0;
    iter_scroll = 0;
    iter_cube = 0;
    prepare_plotb();
    prepare_cube();
    while ( !keypressed() && amp_frame < 5100 )
    {
       clear(dblbuff);
       poll_amp();
       if ( amp_frame < 3600 )
       {
          stop_part2(((amp_frame-3400)*64)/200);
          do_anim2( iteration , 1 );
       }
       do_stars(iter_move);
       do_plotb(iter_scroll);
       if ( amp_frame > 4000 )
       {
          if ( iter_cube < 150 )
            do_cube(iter_cube,0);
          if ( iter_cube > 150 && iter_cube < 250 )
            do_cube(iter_cube,((iter_cube-150) / 20) & 1);
          if ( iter_cube > 250 && iter_cube < 400 )
            do_cube(iter_cube,1);
          if ( iter_cube > 400 && iter_cube < 500 )
            do_cube(iter_cube,1 + (((iter_cube-400) / 20) & 1) );
          if ( iter_cube > 500 )
            do_cube(iter_cube,2);

         iter_cube++;
       }

       if ( iteration < 1350 )
          do_greets(iteration-150,0,126,200);

       if ( amp_frame > 5050 )
          do_123(0);
       if ( amp_frame > 5065 )
          do_123(1);
       if ( amp_frame > 5080 )
          do_123(2);

       iter_move++;
       iteration++;
       iter_scroll++;
       wait_vbl();
       fix_plotb();
       if ( amp_frame > 4000 )
         fix_cube();
       if ( amp_frame < 3600 )
       {
          finalise_anim2();
          fix_pal_stars();
       }
       if ( iteration < 1150 )
          fix_greets(126);
       blit(dblbuff,screen,0,0,0,0,640,480);
    }
    if ( !keypressed() )
    {
       poll_amp();
       stop_123();
       run_amp();
       stop_123();
       poll_amp();
       stop_123();
       poll_amp();
       stop_123();
       poll_amp();
   }

/*--- Partie rapide le final bientot ---*/

    stop_anim2();
    stop_plotb();
    prepare_greets(161);
    prepare_anim3();
    prepare_bump();
    iteration = 0;
    iter_move = 0;
    while ( !keypressed() && amp_frame < 5700 )
    {
       poll_amp();
       do_anim3(iteration,1);

       if(iteration > 50 )
          do_bump(iteration);

       if(iteration > 60 && iteration < 510 )
          do_greets(iteration-60,1,161,50);


       iteration++;
       wait_vbl();
       if ( amp_frame < 5550 )
       {
          finalise_anim3();
          fix_bump();
          fix_greets(161);
       }

       if ( amp_frame > 5500 && amp_frame < 5550 )
         get_palette(tamp_pal);

       if ( amp_frame > 5600 )
       {
          fade_interpolate(tamp_pal,black_palette,tamp_pal,1,0,255);
          set_palette(tamp_pal);
          fix_greets(161);
       }
       blit(dblbuff,screen,0,0,0,0,640,480);
    }


    clear(screen);
    prepare_anim4();
    fix_greets(161);
    while ( !keypressed() && amp_frame < 6740 )
    {
       poll_amp();
       do_anim4(iteration,0);

       if( iteration < 510 )
          do_greets(iteration-60,1,161,50);

       if( iteration > 510 )
          do_greets(iteration - 510, 2,161,71);

       iteration++;
       wait_vbl();
       if ( amp_frame > 5700 && amp_frame < 5850 )
       {
          fade_interpolate(black_palette,pal_anim4,tamp_pal2,
                          (int)((amp_frame-5700)/2.34),0,255);
          set_palette(tamp_pal2);
          fix_greets(161);
       }
       else
       {
          fix_greets(161);
          finalise_anim4();
       }
       blit(dblbuff,screen,0,0,0,0,640,480);

    }

    run_amp();
    if ( !keypressed() )
    {
       stop_123();
    }
    stop_greets();
    stop_anim4();
    stop_bump();

#endif

    clear(screen);
    clear(dblbuff);
    prepare_greets(254);
    prepare_final();
    prepare_bump2();
    fix_greets(254);
    iteration = 0;
    while ( !keypressed() && amp_frame < 7770 )
    {
       poll_amp();
       do_anim5(iteration,1);
       do_final(iteration);
       if ( iteration < 1500 )
          do_greets(iteration,3,254,450);

       iteration++;
       wait_vbl();
       if ( iteration > 900 )
          fix_bump2();
       finalise_anim5();
       blit(dblbuff,screen,0,0,0,0,640,480);
    }
    stop_final();
    stop_greets();
    if ( !keypressed() )
    {
       poll_amp();
       stop_123();
       run_amp();
       stop_123();
       poll_amp();
       stop_123();
       prepare_fin();
       do_fin();
    }



  /*==========================================
   * On ferme
   *==========================================
   */
    stop_rts();
    stop_wobber();
    stop_roto();
    stop_deform();
    stop_stars();
    stop_cube();
    unload_amp();
    allegro_exit();
    exit(0);
}
