/*=====================================
 * Particule en mode point
 *=====================================
 */

#include <allegro.h>
#include "rtsdat.h"





static  int         pos=0;
static  BITMAP   *  bmp;
static  BITMAP   *  spr;
static  MATRIX      mat;

static  fixed       posx[3][256];
static  fixed       posy[3][256];
static  int         coul[3] = {128,160,192};

extern  BITMAP   *  dblbuff;
extern  DATAFILE *  datfile;

/*==============================
 * PRIMITIVES
 *==============================
 */

static dr_truc(int it, int it1,int cdeb)
{
  int i,j;
  int x,y;

   for ( i = 0 ; i < 20 ; i++ )
   {
     x  = fixtoi(posx[it1][it])+320;
     y  = fixtoi(posy[it1][it])+200;
     for( j = 0 ; j < 20 ; j++ )
       if( spr->line[i][j] )
          if ( bmp->line[y+i][x+j] != 0 )
          {
             if ( bmp->line[y+i][x+j] < cdeb+32 )
                   bmp->line[y+i][x+j] += 1;
          }
          else
             bmp->line[y+i][x+j] = cdeb;
   }
}



/*===============================
 * PRINCIPALES
 *===============================
 */
fix_plotb()
{
  RGB * pal = (RGB *)datfile[TRUC_PAL].dat;
  set_palette_range(pal,128,253,0);
}

prepare_plotb()
{
  int i;
  bmp=create_bitmap(640,480);
  clear(bmp);
  spr=create_bitmap(20,20);
  clear(spr);
  for ( i = 0 ; i < 256 ; i++ )
  {
     posx[0][i] = ( 130 * fcos( i << 16 ) )  ;
     posy[0][i] = ( 200  * fsin( i << 16 ) )  ;
  }
  for ( i = 0 ; i < 128 ; i++ )
  {
     posx[1][i] = i << 16;
     posy[1][i] = (  150 * fsin( i << 17 ) )  ;
  }
  for ( i = 128 ; i < 256 ; i++ )
  {
     posx[1][i] = (256 - i) << 16;
     posy[1][i] = -(  150 * fsin( i << 16 ) )  ;
  }

  for ( i = 0 ; i < 128 ; i++ )
  {
     posx[2][i] = (2*i-128) << 16;
     posy[2][i] = (  150 * fsin( i << 17 ) )  ;
  }
  for ( i = 128 ; i < 256 ; i++ )
  {
     posx[2][i] = (128 - 2*(i-128)) << 16;
     posy[2][i] = (  150 * fsin( (i-128) << 17 ) )  ;
  }
  circlefill(spr, 10,10, 8, 128);

  get_z_rotate_matrix(&mat,16<<16);

}


do_plotb(int iter)
{
  fixed  toto;
  int it  = iter & 31;
  int it1 = iter / 512;
  int i;

  it1 %= 3;

  if ( (iter & 511) == 0 ) clear(bmp);

  if ( it == 0 )
    for ( i = 0 ; i < 256 ; i++ )
       apply_matrix(&mat,posx[it1][i],posy[it1][i],0,&posx[it1][i],&posy[it1][i],&toto);


  it = (it << 3);
  for( i = 0 ; i < 8 ; i++, it++ )
     dr_truc(it,it1,coul[it1]);

  masked_blit(bmp,dblbuff,0,0,0,40,640,480);

}





stop_plotb()
{
   return(0);
}

