

/*==============================================
  * Compte a rebour pour la seconde partie de
  * l'intro
  * (c) Disk91 /TeKnO-BeDoUiNs/
  *==============================================
  */
  #include <stdio.h>
  #include <stdlib.h>
  #include <allegro.h>
  #include "rtsdat.h"

  extern BITMAP * dblbuff;
  extern DATAFILE * datfile;

  static BITMAP * texture1;
  static BITMAP * texture2;
  static BITMAP * imgs, *imgd;
  static RGB      color[256];
  static PALETTE  courante;
  static int      plussimple = 0;

  /*==========================
   * Definition des objets
   *==========================
   */

  typedef struct Pt3d  {
                         fixed x;
                         fixed y;
                         fixed z;
                       } t_pt3d;

  typedef struct Fa3d  {
                         int   nb;
                         int   p1;
                         int   p2;
                         int   p3;
                         int   p4;
                       } t_fa3d;

  typedef struct place {
                         fixed tx,ty,tz;
                         fixed rx,ry,rz;
                       } t_place;


  static t_pt3d objbase[12] = {{ -20 << 16,  5 << 16, -4 << 16 },
                               {  20 << 16,  5 << 16, -4 << 16 },
                               {  20 << 16, -5 << 16, -4 << 16 },
                               { -20 << 16, -5 << 16, -4 << 16 },
                               { -20 << 16,  5 << 16,  4 << 16 },
                               {  20 << 16,  5 << 16,  4 << 16 },
                               {  20 << 16, -5 << 16,  4 << 16 },
                               { -20 << 16, -5 << 16,  4 << 16 },
                               { -25 << 16,  0 << 16, -4 << 16 },
                               {  25 << 16,  0 << 16, -4 << 16 },
                               { -25 << 16,  0 << 16,  4 << 16 },
                               {  25 << 16,  0 << 16,  4 << 16 },
                               };

  static t_fa3d facbase[12] = { { 4,  0,  3,  2,  1 },
                                { 4,  0,  1,  5,  4 },
                                { 4,  4,  5,  6,  7 },
                                { 4,  3,  7,  6,  2 },
                                { 3,  8,  3,  0, -1 },
                                { 3, 10,  4,  7, -1 },
                                { 3,  9,  1,  2, -1 },
                                { 3, 11,  6,  5, -1 },
                                { 4,  8,  0,  4, 10 },
                                { 4,  7,  3,  8, 10 },
                                { 4,  1,  9, 11,  5 },
                                { 4,  2,  6, 11,  9 } };

  /*-------------------------------------
   * variable pour la gestion des cercles
   *-------------------------------------
   */
   static V3D     cercle[64];               /* les points du cercle */
   static t_fa3d  facercle[64];             /* les faces du cercle */

   static V3D     cer1[64];                 /* les objets affichables */
   static V3D     cer2[64];

   static int     cer_ord[2][64];              /* trie des faces */
   static int     anglecour = 0;               /* angle pour les cercle */







 /* =====================================
  * Les fonctions
  * =====================================
  */

  /*--- Definitions de tous les objets ---*/

  static t_place position[6][5] =
  /*           tx         ty          tz         rx         ry         rz         */
     { { {   0 << 16, -50 << 16, 100  << 16,          0,         0,  0 << 16 },
         { -25 << 16, -25 << 16, 100  << 16,          0,         0, 64 << 16 },
         {   0 << 16,   0 << 16, 100  << 16,          0,         0,  0 << 16 },
         {  25 << 16,  25 << 16, 100  << 16,          0,         0, 64 << 16 },
         {   0 << 16,  50 << 16, 100  << 16,          0,         0,  0 << 16 }
       },
       { {  25 << 16, -25 << 16, 100  << 16,  512 << 16, 512 << 16, 64 << 16 },
         { -25 << 16, -25 << 16, 100  << 16,  512 << 16, 512 << 16, 64 << 16 },
         {   0 << 16,   0 << 16, 100  << 16,  512 << 16, 512 << 16,  0 << 16 },
         {  25 << 16,  25 << 16, 100  << 16,  512 << 16, 512 << 16, 64 << 16 },
         {   0 << 16,  50 << 16, 3000 << 16,  512 << 16, 512 << 16,  0 << 16 }
       },
       { {  25 << 16, -25 << 16, 100  << 16,          0,         0, 64 << 16 },
         {   0 << 16, -50 << 16, 100  << 16,          0,         0,  0 << 16 },
         {   0 << 16,   0 << 16, 100  << 16,          0,         0,  0 << 16 },
         {  25 << 16,  25 << 16, 100  << 16,          0,         0, 64 << 16 },
         {   0 << 16,  50 << 16, 100  << 16,          0,         0,  0 << 16 }
       },
       { {  25 << 16, -25 << 16, 100  << 16,  512 << 16, 512 << 16, 64 << 16 },
         {   0 << 16, -50 << 16, 100  << 16,  512 << 16, 512 << 16,  0 << 16 },
         {   0 << 16,   0 << 16, 100  << 16,  512 << 16, 512 << 16,  0 << 16 },
         { -25 << 16,  25 << 16, 100  << 16,  512 << 16, 512 << 16, 64 << 16 },
         {   0 << 16,  50 << 16, 100  << 16,  512 << 16, 512 << 16,  0 << 16 }
       },
       { {   0 << 16, -25 << 16, 100  << 16,          0,         0, 64 << 16 },
         {   0 << 16, -50 << 16, 3000 << 16,          0,         0,  0 << 16 },
         {   0 << 16,   0 << 16, 3000 << 16,          0,         0,  0 << 16 },
         {   0 << 16,  25 << 16, 100  << 16,          0,         0, 64 << 16 },
         {   0 << 16,  50 << 16, 3000 << 16,          0,         0,  0 << 16 }
       },
       { {  25 << 16, -25 << 16, 1600 << 16,  512 << 16, 512 << 16, 64 << 16 },
         {   0 << 16, -50 << 16, 3000 << 16,          0,         0,  0 << 16 },
         {   0 << 16,   0 << 16, 3000 << 16,          0,         0,  0 << 16 },
         {  25 << 16,  25 << 16, 1600 << 16,  512 << 16, 512 << 16, 64 << 16 },
         {   0 << 16,  50 << 16, 3000 << 16,          0,         0,  0 << 16 }
       }
     };

  static V3D   affichable[12] = { { 0, 0, 0,  13 << 16,   0 << 16, 10 },
                                  { 0, 0, 0, 115 << 16,   0 << 16, 11 },
                                  { 0, 0, 0, 115 << 16,  36 << 16, 12 },
                                  { 0, 0, 0,  13 << 16,  36 << 16, 13 },
                                  { 0, 0, 0,  13 << 16, 100 << 16, 14 },
                                  { 0, 0, 0, 115 << 16, 100 << 16, 15 },
                                  { 0, 0, 0, 115 << 16,  64 << 16, 16 },
                                  { 0, 0, 0,  13 << 16,  64 << 16, 17 },
                                  { 0, 0, 0,   0 << 16,  18 << 16, 18 },
                                  { 0, 0, 0, 127 << 16,  18 << 16, 19 },
                                  { 0, 0, 0,   0 << 16,  81 << 16, 20 },
                                  { 0, 0, 0, 127 << 16,  81 << 16, 21 } };



   /*--------------------------------
    * Primitives pour quick sort
    *--------------------------------
    */
   static int fnctri( const void * e1, const void * e2)
   {
      fixed zmoy1, zmoy2;
      int * v1 = ( int *) e1;
      int * v2 = ( int *) e2;

      if ( facbase[*v1].nb == 4 )
         zmoy1 =( affichable[facbase[*v1].p1].z + affichable[facbase[*v1].p2].z +
                  affichable[facbase[*v1].p3].z + affichable[facbase[*v1].p4].z ) / 4;
      else
         zmoy1 =( affichable[facbase[*v1].p1].z + affichable[facbase[*v1].p2].z +
                  affichable[facbase[*v1].p3].z ) / 3;
      if ( facbase[*v2].nb == 4 )
         zmoy2 =( affichable[facbase[*v2].p1].z + affichable[facbase[*v2].p2].z +
                  affichable[facbase[*v2].p3].z + affichable[facbase[*v2].p4].z ) / 4;
      else
         zmoy2 =( affichable[facbase[*v2].p1].z + affichable[facbase[*v2].p2].z +
                  affichable[facbase[*v2].p3].z ) / 3;

      return zmoy2 - zmoy1;
   }

   static int fnctri2a( const void * e1, const void * e2)
   {
      fixed zmoy1, zmoy2;
      int * v1 = ( int *) e1;
      int * v2 = ( int *) e2;

      zmoy1 =( cer1[facercle[*v1].p1].z + cer1[facercle[*v1].p2].z +
               cer1[facercle[*v1].p3].z + cer1[facercle[*v1].p4].z );
      zmoy2 =( cer1[facercle[*v2].p1].z + cer1[facercle[*v2].p2].z +
               cer1[facercle[*v2].p3].z + cer1[facercle[*v2].p4].z );
      return zmoy2 - zmoy1;
   }

   static int fnctri2b( const void * e1, const void * e2)
   {
      fixed zmoy1, zmoy2;
      int * v1 = ( int *) e1;
      int * v2 = ( int *) e2;

      zmoy1 =( cer2[facercle[*v1].p1].z + cer2[facercle[*v1].p2].z +
               cer2[facercle[*v1].p3].z + cer2[facercle[*v1].p4].z );
      zmoy2 =( cer2[facercle[*v2].p1].z + cer2[facercle[*v2].p2].z +
               cer2[facercle[*v2].p3].z + cer2[facercle[*v2].p4].z );
      return zmoy2 - zmoy1;
   }


  /*--------------------------------
   * Primitives
   *--------------------------------
   */

   /*--- primitive d'affichage d'un objet ---*/

   static rebour_drobj( MATRIX * mat )
   {
      static V3D * faces[4];

      int    trifac[12] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 };
      int    i;

      for ( i = 0 ; i < 12 ; i++ )
      {
         apply_matrix(mat, objbase[i].x, objbase[i].y, objbase[i].z,
                      &affichable[i].x, &affichable[i].y, &affichable[i].z );

         persp_project(affichable[i].x,affichable[i].y, affichable[i].z,
                       &affichable[i].x,&affichable[i].y );

      }

      qsort( trifac, 12, sizeof(int), fnctri );

      for ( i = 0 ; i < 12 ; i++ )
      {
         faces[0] = &affichable[facbase[trifac[i]].p1];
         faces[1] = &affichable[facbase[trifac[i]].p2];
         faces[2] = &affichable[facbase[trifac[i]].p3];
         faces[3] = &affichable[facbase[trifac[i]].p4];
         if ( polygon_z_normal(faces[0],faces[1],faces[2]) > 0 )
            polygon3d(dblbuff,POLYTYPE_ATEX,texture1,facbase[trifac[i]].nb, faces);
      }
   }

   /*--- Transition entre deux matrices en 10 etapes ---*/
   static transit_mat( t_place * mats, t_place * matd, t_place * out, int pass )
   {
      out->tx = mats->tx + ( ( (matd->tx - mats->tx) >> 5 ) * pass );
      out->ty = mats->ty + ( ( (matd->ty - mats->ty) >> 5 ) * pass );
      out->tz = mats->tz + ( ( (matd->tz - mats->tz) >> 5 ) * pass );
      out->rx =( mats->rx + ( ( (matd->rx - mats->rx) >> 5 ) * pass ) ) & 0xffffff;
      out->ry =( mats->ry + ( ( (matd->ry - mats->ry) >> 5 ) * pass ) ) & 0xffffff;
      out->rz =( mats->rz + ( ( (matd->rz - mats->rz) >> 5 ) * pass ) ) & 0xffffff;
   }

  /*==========================================
   * Primitives pour l'objet disque
   *==========================================
   */


   static make_nobject()
   {
      int i,j;

      /*--- description des points ---*/
      for (i = 0 ; i < 16 ; i++)
      {
         cercle[4*i  ].x = 65*fcos( i << 20 );
         cercle[4*i  ].y = 65*fsin( i << 20 );
         cercle[4*i  ].z = -3 << 16;
         cercle[4*i  ].u = 0;
         cercle[4*i  ].v = 0;

         cercle[4*i+1].x = 68*fcos( i << 20 );
         cercle[4*i+1].y = 68*fsin( i << 20 );
         cercle[4*i+1].z = -3 << 16;
         cercle[4*i+1].u = 20 << 16;
         cercle[4*i+1].v = 0;

         cercle[4*i+2].x = cercle[4*i  ].x;
         cercle[4*i+2].y = cercle[4*i  ].y;
         cercle[4*i+2].z = 3 << 16;
         cercle[4*i+2].u = 52 << 16;
         cercle[4*i+2].v = 0;

         cercle[4*i+3].x = cercle[4*i+1].x;
         cercle[4*i+3].y = cercle[4*i+1].y;
         cercle[4*i+3].z = 3 << 16;
         cercle[4*i+3].u = 32 << 16;
         cercle[4*i+3].v = 0;
      }

      /*--- description des faces ---*/

      for (i = 0 ; i < 16 ; i++ )
      {
        facercle[4*i  ].p1 = 4*i;
        facercle[4*i  ].p2 = 4*i    +1;
        facercle[4*i  ].p3 = 4*(i+1)+1 & 63;
        facercle[4*i  ].p4 = 4*(i+1)   & 63;
        facercle[4*i  ].nb = 4;


        facercle[4*i+1].p1 = 4*i    +2;
        facercle[4*i+1].p2 = 4*(i+1)+2 & 63;
        facercle[4*i+1].p3 = 4*(i+1)+3 & 63;
        facercle[4*i+1].p4 = 4*i    +3;
        facercle[4*i  ].nb = 2;

        facercle[4*i+2].p1 = 4*i;
        facercle[4*i+2].p2 = 4*(i+1)   & 63;
        facercle[4*i+2].p3 = 4*(i+1)+2 & 63;
        facercle[4*i+2].p4 = 4*i    +2;
        facercle[4*i  ].nb = 2;

        facercle[4*i+3].p1 = 4*i    +1;
        facercle[4*i+3].p2 = 4*i    +3;
        facercle[4*i+3].p3 = 4*(i+1)+3 & 63;
        facercle[4*i+3].p4 = 4*(i+1)+1 & 63;
        facercle[4*i  ].nb = 4;
      }
   }


   /*--- Realise la translation rotation des cercle avec projection et trie sur z ---*/
   modif_nobject(int angle)
   {
      MATRIX mat1,mat2;
      int i;

      get_transformation_matrix( &mat1, itofix(1), itofix(angle), itofix(angle),   itofix(angle),
                                  0, 0, itofix(100) );
      get_transformation_matrix( &mat2, itofix(1), itofix(angle+64), itofix(angle), itofix(angle),
                                  0, 0, itofix(100) );

      for ( i = 0 ; i < 64 ; i++ )
      {
         apply_matrix(&mat1, cercle[i].x, cercle[i].y, cercle[i].z,
                      &cer1[i].x, &cer1[i].y, &cer1[i].z );
         apply_matrix(&mat2, cercle[i].x, cercle[i].y, cercle[i].z,
                      &cer2[i].x, &cer2[i].y, &cer2[i].z );

         persp_project(cer1[i].x,cer1[i].y, cer1[i].z,&cer1[i].x,&cer1[i].y );
         persp_project(cer2[i].x,cer2[i].y, cer2[i].z,&cer2[i].x,&cer2[i].y );

         cer_ord[0][i] = cer_ord[1][i] = i;
         cer1[i].c = cer2[i].c = cercle[i].c;
         cer1[i].u = cer2[i].u = cercle[i].u;
         cer1[i].v = cer2[i].v = cercle[i].v;
      }

      /* trie des faces par objet sur z */

      qsort( cer_ord[0], 64, sizeof(int), fnctri2a );
      qsort( cer_ord[1], 64, sizeof(int), fnctri2b );
  }

  /*--- affiche la premiere partie des objets cercle ( moitier la plus loin ) ---*/

  dr_cercle1()
  {
      int i,k;

      for ( i = 0 ; i < 32 ; i++ )
      {
         if ( polygon_z_normal(&cer1[facercle[cer_ord[0][i]].p1],
                               &cer1[facercle[cer_ord[0][i]].p2],
                               &cer1[facercle[cer_ord[0][i]].p3] ) )
         {
            cer1[facercle[cer_ord[0][i]].p3].v = 63 << 16;
            if ( facercle[cer_ord[0][i]].nb == 2 )
                  cer1[facercle[cer_ord[0][i]].p2].v = 63 << 16;
            else  cer1[facercle[cer_ord[0][i]].p4].v = 63 << 16;

            quad3d(dblbuff, POLYTYPE_ATEX, texture2, &cer1[facercle[cer_ord[0][i]].p1],
                                                     &cer1[facercle[cer_ord[0][i]].p2],
                                                     &cer1[facercle[cer_ord[0][i]].p3],
                                                     &cer1[facercle[cer_ord[0][i]].p4] );
            cer1[facercle[cer_ord[0][i]].p3].v = 0;
            cer1[facercle[cer_ord[0][i]].p4].v = 0;
            cer1[facercle[cer_ord[0][i]].p2].v = 0;
         }

         if ( polygon_z_normal(&cer2[facercle[cer_ord[1][i]].p1],
                               &cer2[facercle[cer_ord[1][i]].p2],
                               &cer2[facercle[cer_ord[1][i]].p3] ) )
         {
            cer2[facercle[cer_ord[1][i]].p3].v = 63 << 16;
            if ( facercle[cer_ord[1][i]].nb == 2 )
                 cer2[facercle[cer_ord[1][i]].p2].v = 63 << 16;
            else cer2[facercle[cer_ord[1][i]].p4].v = 63 << 16;

            quad3d(dblbuff, POLYTYPE_ATEX, texture2, &cer2[facercle[cer_ord[1][i]].p1],
                                                     &cer2[facercle[cer_ord[1][i]].p2],
                                                     &cer2[facercle[cer_ord[1][i]].p3],
                                                     &cer2[facercle[cer_ord[1][i]].p4] );
            cer2[facercle[cer_ord[1][i]].p3].v = 0;
            cer2[facercle[cer_ord[1][i]].p4].v = 0;
            cer2[facercle[cer_ord[1][i]].p2].v = 0;

         }
      }
  }

  /*--- affiche la seconde partie des objets cercle ( moitier la plus pres ) ---*/

  dr_cercle2()
  {
      int i,k;

      for ( i = 32 ; i < 64 ; i++ )
      {
         if ( polygon_z_normal(&cer1[facercle[cer_ord[0][i]].p1],
                               &cer1[facercle[cer_ord[0][i]].p2],
                               &cer1[facercle[cer_ord[0][i]].p3] ) )
         {
            cer1[facercle[cer_ord[0][i]].p3].v = 63 << 16;
            if ( facercle[cer_ord[0][i]].nb == 2 )
                 cer1[facercle[cer_ord[0][i]].p2].v = 63 << 16;
            else cer1[facercle[cer_ord[0][i]].p4].v = 63 << 16 ;

            quad3d(dblbuff, POLYTYPE_ATEX, texture2, &cer1[facercle[cer_ord[0][i]].p1],
                                                     &cer1[facercle[cer_ord[0][i]].p2],
                                                     &cer1[facercle[cer_ord[0][i]].p3],
                                                     &cer1[facercle[cer_ord[0][i]].p4] );
            cer1[facercle[cer_ord[0][i]].p3].v = 0;
            cer1[facercle[cer_ord[0][i]].p4].v = 0;
            cer1[facercle[cer_ord[0][i]].p2].v = 0;
         }

         if ( polygon_z_normal(&cer2[facercle[cer_ord[1][i]].p1],
                               &cer2[facercle[cer_ord[1][i]].p2],
                               &cer2[facercle[cer_ord[1][i]].p3] ) )
         {
            cer2[facercle[cer_ord[1][i]].p3].v = 63 << 16;
            if ( facercle[cer_ord[1][i]].nb == 2 )
                 cer2[facercle[cer_ord[1][i]].p2].v = 63 << 16;
            else cer2[facercle[cer_ord[1][i]].p4].v = 63 << 16;

            quad3d(dblbuff, POLYTYPE_ATEX, texture2, &cer2[facercle[cer_ord[1][i]].p1],
                                                     &cer2[facercle[cer_ord[1][i]].p2],
                                                     &cer2[facercle[cer_ord[1][i]].p3],
                                                     &cer2[facercle[cer_ord[1][i]].p4] );
            cer2[facercle[cer_ord[1][i]].p3].v = 0;
            cer2[facercle[cer_ord[1][i]].p4].v = 0;
            cer2[facercle[cer_ord[1][i]].p2].v = 0;

         }
      }
  }

  /*========================================================
   * Procedures principales
   *========================================================
   */

  /*--------------------------------
   * Fonction d'initialisation
   *--------------------------------
   */


   prepare_rebour()
   {
      int i,j;
      RGB * pal  = (RGB *)datfile[REBOUR1_PAL].dat;
      RGB * pal2 = (RGB *)datfile[REBOUR2_PAL].dat;
      RGB * pal3 = (RGB *)datfile[VNF0_PAL].dat;

      set_projection_viewport(0,0,SCREEN_W,SCREEN_H);
      texture1 = datfile[REBOUR1_PCX].dat;
      for ( i = 0 ; i < texture1->h ; i++ )
       for ( j = 0 ; j < texture1->w ; j++ )
          texture1->line[i][j]++;
      for ( i = 1 ; i < 33 ; i++ )
         color[i] =  pal[i-1];

      texture2 = datfile[REBOUR2_PCX].dat;
      for ( i = 0 ; i < texture2->h ; i++ )
       for ( j = 0 ; j < texture2->w ; j++ )
          texture2->line[i][j] +=33;
      for ( i = 0 ; i < 32 ; i++ )
         color[i+33] =  pal2[i];

      /*--- image de fond ---*/

      imgs = datfile[VNF0_PCX].dat;
      imgd = create_bitmap(640,480);
      blit(imgs,imgd,0,0,0,0,640,480);
      for ( i = 0 ; i < imgd->h ; i++ )
       for ( j = 0 ; j < imgd->w ; j++ )
          imgd->line[i][j] +=65;
      for ( i = 0 ; i < 32 ; i++ )
         color[i+65] =  pal3[i];

      make_nobject();

   }


  /*----------------------------------
   * Fontion d'iteration
   *----------------------------------
   */

   do_rebour(int k)
   {
      MATRIX transfo;
      int i,j;
      int src,dest,iter;
      t_place transrotmat[5];
      int ordre[5] = { 0, 1, 3, 4, 2 };

        if ( k < 32 )
        {
           fade_interpolate(black_palette, color, courante,  (k << 1) , 65, 98 );
           set_palette_range(courante, 65, 98, 0);
           set_palette_range(color, 0, 64, 0);
        }

         modif_nobject(anglecour);              // calcul des nouvelles positions pour cercles
         blit(imgd,dblbuff,0,0,0,0,640,480);
         dr_cercle1();                          // trace la premiere partie des cercle

         if ( k > 192 ) k = 192;
         src  = k >> 5;
         dest = src + 1;
         iter = k & 31;
         for ( j = 0 ; j < 5 ; j++ )
         {
            i = ordre[j];
            transit_mat( &position[src][i], &position[dest][i], &transrotmat[i], iter );
            get_transformation_matrix( &transfo, itofix(1), transrotmat[i].rx,
                                       transrotmat[i].ry, transrotmat[i].rz,
                                       transrotmat[i].tx, transrotmat[i].ty,
                                       transrotmat[i].tz );
            if ( transfo.t[2] < (1500 << 16 ) )         // clipping sur z
               rebour_drobj( &transfo );
         }

         dr_cercle2();                                 // trace la seconde partie
         anglecour = (anglecour + 3)  & 255 ;


   }



   stop_rebour()
   {
       RGB color = { 63,63,63 };
       int i;
       for (i = 0 ; i < 256 ; i++)
          set_color(i,&color);
       fade_out( 4 );
       destroy_bitmap(imgd);
   }


  /*============================================
   * POUR LA SECONDE UTILISATION
   *============================================
   */

   prepare_rebour2(BITMAP * imgf, PALETTE palf)
   {
      int i,j;

      /*--- image de fond ---*/

      blit(imgf,imgd,0,0,0,0,640,480);
      for ( i = 0 ; i < imgd->h ; i++ )
       for ( j = 0 ; j < imgd->w ; j++ )
          imgd->line[i][j] +=65;
      for ( i = 0 ; i < 100 ; i++ )
         color[i+65] =  palf[i];
      set_palette_range(color, 65, 165, 0);
      set_palette_range(color, 1, 64, 0);

      anglecour = 0;

   }


   do_rebour2(int k)
   {
      MATRIX transfo;
      int i,j;
      int src,dest,iter;
      t_place transrotmat[5];
      int ordre[5] = { 0, 1, 3, 4, 2 };

         if ( plussimple < 64 )
         {
           fade_interpolate(color,black_palette, courante, 1, 65, 165 );
           set_palette_range(courante, 65, 165, 0);
           plussimple++;
         }


         modif_nobject(anglecour);              // calcul des nouvelles positions pour cercles
         blit(imgd,dblbuff,0,0,0,0,640,480);
         dr_cercle1();                          // trace la premiere partie des cercle

         if ( k < 64 ) k = 64;
         src  = k >> 5;
         dest = src + 1;
         iter = k & 31;
         for ( j = 0 ; j < 5 ; j++ )
         {
            i = ordre[j];
            transit_mat( &position[src][i], &position[dest][i], &transrotmat[i], iter );
            get_transformation_matrix( &transfo, itofix(1), transrotmat[i].rx,
                                       transrotmat[i].ry, transrotmat[i].rz,
                                       transrotmat[i].tx, transrotmat[i].ty,
                                       transrotmat[i].tz );
            if ( transfo.t[2] < (1500 << 16 ) )         // clipping sur z
               rebour_drobj( &transfo );
         }

         dr_cercle2();                                 // trace la seconde partie
         anglecour = (anglecour + 3)  & 255 ;


   }

   stop_rebour2()
   {
       RGB white = { 63,63,63,0 };
       int i;
       for (i = 0 ; i < 256 ; i++)
          set_color(i,&white);
       fade_out( 2 );
   }


