/*============================================
 * Rotozoom taille 160*100 pour rts
 * (c) Disk91 / TeKnO-BeDoUiNs /
 *============================================
 */

#include <allegro.h>
#include <math.h>
#include "rtsdat.h"

/*-------------------------------
 * GLOBALES
 *-------------------------------
 */
         extern       DATAFILE * datfile;
         extern       BITMAP   * dblbuff;

                      int      ROTO_SRC[4096];
                      BITMAP * ROTO_DST;
         static       int      ROTO_ANGLE;
         static       int      ROTO_CX;
         static       int      ROTO_CY;

         static       int    * ROTO_COS = NULL;
         static       int    * ROTO_SIN = NULL;

         static       int      CenterX[90];
         static       int      CenterY[90];
         static       int      cnt;
         static       RGB      color[256];

         static       int      posx[64];
         static       int      posy[64];

 /*--------------------------------
  * PRIMITIVES
  *--------------------------------
  */

 static void precalc(void)
            {
              /*precalcul tous les tab*/

              /*alocation de memoire :ROTO_COS et ROTO_SIN : 2*460800 octet*/
              /*avec tableaux short int*/

              int       j;
              double    k,i;

              ROTO_COS = ( int *) malloc (30*180*sizeof(int));
              ROTO_SIN = ( int *) malloc (30*180*sizeof(int));

              if ( !ROTO_COS || !ROTO_SIN )
              {
                allegro_exit();
                printf("  Allocation de memoire pour lee rotozoom impossible \n");
                printf("   vous devez avoir : %d Ko libres\n",60*180*sizeof(short int)/1024);
                exit(1);
              }

              // par 128 on a une optim sup pour les map de 128 sutout lorsque le tps augmente (avec zoom)

              k=0.000001;
              i=0;
              for ( j = 0 ; j < 5400 ; j++ )
              {
                 i += 2*sin(j*1.5*0.0174532925199);

                 ROTO_COS[j] = ( int )((512+512*(sin(k)/(k)))*cos(i*0.0174532925199));   /*tableau des cos(a)*/
                 ROTO_SIN[j] = ( int )((512+1024*(sin(k)/(k)))*sin(i*0.0174532925199));   /*tableau des sin(a)*/
                 if ( ((j/720) % 2) == 0  )
                   k += 0.0131;
                 else
                   k -= 0.0131;

              }

              for ( j=0;j < 90;j++ )
              {
                 CenterX[j] = ( int)(-128+16*cos(j*4*0.0174532925199));
                 CenterY[j] = ( int)(-128+20*sin(j*4*0.0174532925199));
              }

}

Roto_Redraw_64_bis(int posx, int posy, int tx, int ty)
{
   int anglex,angley;
   int centrex,centrey;
   int x,y;
   int t1,t2;
   int * ofs;
   int  value;

   anglex  = ROTO_COS[ROTO_ANGLE];
   angley  = ROTO_SIN[ROTO_ANGLE];

   centrex = ROTO_CX * ( anglex - angley );
   centrey = ROTO_CY * ( anglex + angley );
   tx      = tx >> 2;

   for ( y = 0 ; y < ty ; y++ )
   {
      t1 = centrex ;
      t2 = centrey ;
      ofs = (int *) ( ROTO_DST->line[y+posy] + posx);
      for ( x = 0 ; x < tx ; x++, ofs++ )
      {
         value  = ROTO_SRC[((t2 & 0xFC00) >> 4) + ((t1 & 0xFC00) >> 10 )];
         t1 -= anglex;
         t2 -= angley;
         value += ROTO_SRC[((t2 & 0xFC00) >> 4) + ((t1 & 0xFC00) >> 10 )] << 8;
         t1 -= anglex;
         t2 -= angley;
         value += ROTO_SRC[((t2 & 0xFC00) >> 4) + ((t1 & 0xFC00) >> 10 )] << 16;
         t1 -= anglex;
         t2 -= angley;
         value += ROTO_SRC[((t2 & 0xFC00) >> 4) + ((t1 & 0xFC00) >> 10 )] << 24;
         *ofs = value;
      }
      centrex -= angley;
      centrey += anglex;
   }
}

/*-----------------------------------------
 *  Ŀ
 *                                       
 *   FONCTIONS D'INIT DU ROTOZOOM        
 *                                       
 *  
 *-----------------------------------------
 */

  void Calc_Roto()
  {
             ROTO_CX = -128;
             ROTO_CY = -128;
             precalc();
             ROTO_ANGLE=0;
  }

  void prepare_roto()
       {
             int      i,j;
             RGB   *  pal;
             RGB      white = {63,63,63,0};
             BITMAP * bmp;

             bmp = datfile[ROTOM1_PCX].dat;
             pal = (RGB *)datfile[ROTOM1_PAL].dat;
             for ( i = 0 ; i < bmp->h ; i++ )
               for ( j = 0 ; j < bmp->w ; j++ )
                  ROTO_SRC[(i << 6) + j] = (int) bmp->line[i][j] + 64;
             for ( i = 0 ; i < 32 ; i++ )
                  color[i+64] =  pal[i];

             set_palette_range(color,64,96,0);
             set_color(97,&white);
             ROTO_DST = dblbuff;


             /*--- calcul des position pour le centre ---*/

             for( i = 0 ; i < 64 ; i++ )
             {
                posx[i] = 20 * cos((float)(i*11.25*PI)/180.0 );
                posy[i] = 20 * sin((float)(i*11.25*PI)/180.0 );
             }

       }

/*  Ŀ
                                         
     FONCTIONS D'EXEC DU ROTOZOOM        
                                         
    
*/

  void do_roto(int iter, int x, int y, int tx, int ty, int transition)
       {
            ROTO_CX = CenterX[cnt];
            ROTO_CY = CenterY[cnt];

            if ( transition )
            {
               x += posx[iter & 63];
               y += posy[iter & 63];
               rect(dblbuff,x,y,x+tx,y+ty,97);
               x++;y++;tx--;ty--;
            }
            if ( transition == 1  && iter < 50 )
               Roto_Redraw_64_bis(x,y,(int)( (tx / 50.0 ) * iter),
                                      (int)( (ty / 50.0 ) * iter) );
            else
               Roto_Redraw_64_bis(x,y,tx,ty);
            ROTO_ANGLE == 5399 ? ROTO_ANGLE = 0  : ROTO_ANGLE++;
            cnt == 89 ? cnt = 0 : cnt ++;
       }

/*  Ŀ
                                         
     FONCTIONS QUITTE DU ROTOZOOM        
                                         
    
*/

  void stop_roto()
       {
           free(ROTO_COS);
           free(ROTO_SIN);
       }

